
package net.mcreator.puzzle_code.network;

import net.neoforged.neoforge.network.handling.IPayloadContext;
import net.neoforged.fml.event.lifecycle.FMLCommonSetupEvent;
import net.neoforged.fml.common.EventBusSubscriber;
import net.neoforged.bus.api.SubscribeEvent;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.protocol.common.custom.CustomPacketPayload;
import net.minecraft.network.protocol.PacketFlow;
import net.minecraft.network.codec.StreamCodec;
import net.minecraft.network.chat.Component;
import net.minecraft.network.RegistryFriendlyByteBuf;
import net.minecraft.core.BlockPos;

import net.mcreator.puzzle_code.world.inventory.CreativeSettingsGUICreativeItemsMenu;
import net.mcreator.puzzle_code.procedures.GiveStructureVoidCreativeSettingsProcedure;
import net.mcreator.puzzle_code.procedures.GiveStructureBlockCreativeSettingsProcedure;
import net.mcreator.puzzle_code.procedures.GiveDebugStickCreativeSettingsProcedure;
import net.mcreator.puzzle_code.procedures.GiveCommandBlockMinecartCreativeSettingsProcedure;
import net.mcreator.puzzle_code.procedures.GiveCommandBlockCreativeSettingsProcedure;
import net.mcreator.puzzle_code.procedures.GiveBarrierCreativeSettingsProcedure;
import net.mcreator.puzzle_code.procedures.CreativeSettingsGUIRightClickProcedure;
import net.mcreator.puzzle_code.PuzzleCodeMod;

import java.util.HashMap;

@EventBusSubscriber(bus = EventBusSubscriber.Bus.MOD)
public record CreativeSettingsGUICreativeItemsButtonMessage(int buttonID, int x, int y, int z) implements CustomPacketPayload {

	public static final Type<CreativeSettingsGUICreativeItemsButtonMessage> TYPE = new Type<>(ResourceLocation.fromNamespaceAndPath(PuzzleCodeMod.MODID, "creative_settings_gui_creative_items_buttons"));
	public static final StreamCodec<RegistryFriendlyByteBuf, CreativeSettingsGUICreativeItemsButtonMessage> STREAM_CODEC = StreamCodec.of((RegistryFriendlyByteBuf buffer, CreativeSettingsGUICreativeItemsButtonMessage message) -> {
		buffer.writeInt(message.buttonID);
		buffer.writeInt(message.x);
		buffer.writeInt(message.y);
		buffer.writeInt(message.z);
	}, (RegistryFriendlyByteBuf buffer) -> new CreativeSettingsGUICreativeItemsButtonMessage(buffer.readInt(), buffer.readInt(), buffer.readInt(), buffer.readInt()));
	@Override
	public Type<CreativeSettingsGUICreativeItemsButtonMessage> type() {
		return TYPE;
	}

	public static void handleData(final CreativeSettingsGUICreativeItemsButtonMessage message, final IPayloadContext context) {
		if (context.flow() == PacketFlow.SERVERBOUND) {
			context.enqueueWork(() -> {
				Player entity = context.player();
				int buttonID = message.buttonID;
				int x = message.x;
				int y = message.y;
				int z = message.z;
				handleButtonAction(entity, buttonID, x, y, z);
			}).exceptionally(e -> {
				context.connection().disconnect(Component.literal(e.getMessage()));
				return null;
			});
		}
	}

	public static void handleButtonAction(Player entity, int buttonID, int x, int y, int z) {
		Level world = entity.level();
		HashMap guistate = CreativeSettingsGUICreativeItemsMenu.guistate;
		// security measure to prevent arbitrary chunk generation
		if (!world.hasChunkAt(new BlockPos(x, y, z)))
			return;
		if (buttonID == 0) {

			GiveCommandBlockCreativeSettingsProcedure.execute(entity);
		}
		if (buttonID == 1) {

			GiveBarrierCreativeSettingsProcedure.execute(entity);
		}
		if (buttonID == 2) {

			GiveCommandBlockMinecartCreativeSettingsProcedure.execute(entity);
		}
		if (buttonID == 3) {

			CreativeSettingsGUIRightClickProcedure.execute(world, x, y, z, entity);
		}
		if (buttonID == 4) {

			GiveDebugStickCreativeSettingsProcedure.execute(entity);
		}
		if (buttonID == 5) {

			GiveStructureVoidCreativeSettingsProcedure.execute(entity);
		}
		if (buttonID == 6) {

			GiveStructureBlockCreativeSettingsProcedure.execute(entity);
		}
	}

	@SubscribeEvent
	public static void registerMessage(FMLCommonSetupEvent event) {
		PuzzleCodeMod.addNetworkMessage(CreativeSettingsGUICreativeItemsButtonMessage.TYPE, CreativeSettingsGUICreativeItemsButtonMessage.STREAM_CODEC, CreativeSettingsGUICreativeItemsButtonMessage::handleData);
	}
}
